100  REM YOUR VERY OWN Text Processor
110  REM Copyright 1985 by Melvin O. Duke.
120  REM Date of last update: 17 May 1985.
130  '
140  REM Device Constants
150  WIDTH "scrn:",80
160  SCREEN 0,1,0,0
170  '
180  REM Dimension Statements for Messages, Arrays, and Vectors
190  DIM TAG$(600)
200  '
210  REM Set Printer Characteristics
220  WIDE.ON$     = CHR$(14)          'Set Expanded Print ON
230  WIDE.OFF$    = CHR$(18)          'Set Expanded Print OFF
240  BOLD.ON$     = CHR$(27)+"E"      'Set Emphasized Print ON
250  BOLD.OFF$    = CHR$(27)+"F"      'Set Emphasized Print OFF
260  SQUEEZE.ON$  = CHR$(15)          'Set Compressed Print ON
270  SQUEEZE.OFF$ = CHR$(18)          'Set Compressed Print OFF
280  PAGE.EJECT$  = CHR$(12)          'Skip to Top of Next Page
290  '
300  REM Set Masks for Compressed Printing
310  MASK$(0) = SPACE$(89)
320  MASK$(1) = "+"+STRING$(87,"-")+"+"
330  MASK$(2) = "|"+STRING$(87," ")+"|"
340  MASK$(3) = "|    +"+STRING$(77,"-")+"+    |"
350  MASK$(4) = "|    |"+STRING$(77," ")+"|    |"
360  MASK$(5) = "|    +----+"+STRING$(72,"-")+"+    |"
370  MASK$(6) = "|    |    |"+STRING$(72," ")+"|    |"
380  MASK$(7) = "|    |                                      |                                      |    |"
390  MASK$(8) = STRING$(80,"=")
400  MASK$(9) = SPACE$(80)
410  '
420  REM Data File Constants
430  DATAFILE$ = "datafile"
440  ARRAY$    = "array"
450  SUBARRAY$ = "subarray"
460  VECTOR1$  = "vector1"
470  VECTOR2$  = "vector2"
480  VECTOR3$  = "vector3"
490  '
500  OPEN "messages" FOR INPUT AS #2
510  INPUT #2, TITLE$
520  TITLE1$ = "Documentation for YOUR VERY OWN " + TITLE$
530  INPUT #2, VERSION$
540  INPUT #2, COPY1$
550  INPUT #2, COPY2$
560  INPUT #2, COPY3$
570  '
580  REM Program Constants for Arrays
590  LDIM = 0 : UDIM = 16
600  '
610  REM Produce the first screen
620  KEY OFF : CLS
630  REM Draw the outer double box
640  R1 = 1 : C1 = 1 : R2 = 24 : C2 = 79 : GOSUB 1770
650  REM Find the title location
660  TITLE.POS = 40 - INT(LEN(TITLE1$)/2)
670  REM Draw the title box
680  R1=2:C1=TITLE.POS-4:R2=5:C2=TITLE.POS+LEN(TITLE1$)+3:GOSUB 1940
690  REM Print the Program Title and Version
700  LOCATE 3,TITLE.POS : PRINT TITLE1$
710  LOCATE 4,39-INT(LEN(VERSION$)/2) :  PRINT VERSION$;
720  '
730  REM Draw the Box to Identify the Collection of Programs
740  R1 = 6 : C1 =  5 : R2 = 18 : C2 = 75 : GOSUB 1770
750  REM Fill in the Box with Descriptions
760  LOCATE  7,7
770  PRINT "One of the Integrated-Information Management, Inquiry and Reporting"
780  LOCATE  8,10
790  PRINT "(I-IMIR) Series of Programs for the IBM PC Family of Computers."
800  REM Draw the IMIR Box and Fill it in.
810  LOCATE 10,13
820  PRINT "If you are using this program, and finding it of value,";
830  LOCATE 11,14
840  PRINT "your contribution ($35 suggested) will be anticipated.";
850  REM Draw the Box to Identify the Use, and Fill it in
860  R1 = 12 : C1 = 28 : R2 = 17 : C2 = 52 : GOSUB 1940
870  LOCATE 13,33 : PRINT "Melvin O. Duke"
880  LOCATE 14,33 : PRINT "P.O. Box 20836"
890  LOCATE 15,31 : PRINT "San Jose, CA  95160"
900  LOCATE 16,33 : PRINT "(408) 268-6637"
910  '
920  REM Draw the Copyright box
930  R1 = 19 : C1 = 24 : R2 = 23 : C2 = 56 : GOSUB 1770
940  REM Print the Copyright
950  LOCATE 20,40-INT(LEN(COPY1$)/2) :  PRINT COPY1$;
960  LOCATE 21,40-INT(LEN(COPY2$)/2) :  PRINT COPY2$;
970  LOCATE 22,40-INT(LEN(COPY3$)/2) :  PRINT COPY3$;
980  '
990  REM ask user to press a key to continue
1000  LOCATE 25,1
1010  PRINT "Press any key to continue.";
1020  K$ = INKEY$ : IF K$ = "" THEN 1020
1030  '
1040  REM Obtain Program Messages
1050  CLS : LOCATE 23,1 : PRINT "Preparing Program Messages"
1060  FOR M.NO = 0 TO 39
1070    LINE INPUT #2, TAG$(M.NO)
1080    PRINT TAG$(M.NO),
1090  NEXT M.NO
1100  TAG$(40) = TITLE$
1110  PRINT
1120  CLOSE #2
1130  '
1140  REM Obtain Current Content of Vector1
1150  PRINT "Preparing ";TAG$(1)
1160  OPEN VECTOR1$ FOR INPUT AS #2
1170  FOR CT = LDIM TO UDIM
1180   LINE INPUT #2, TAG$(100+CT)
1190   PRINT TAG$(100+CT),
1200  NEXT CT
1210  PRINT
1220  CLOSE #2
1230  '
1240  REM Obtain Current Content of Vector3
1250  PRINT "Preparing ";TAG$(2)
1260  OPEN VECTOR3$ FOR INPUT AS #2
1270  FOR CT = LDIM TO UDIM
1280   LINE INPUT #2, TAG$(300 + CT)
1290   PRINT TAG$(300 + CT),
1300  NEXT CT
1310  PRINT
1320  CLOSE #2
1330  '
1340  REM Obtain Current Content of the Array
1350  PRINT "Preparing ";TAG$(3)
1360  OPEN ARRAY$ FOR INPUT AS #2
1370  FOR CT = LDIM TO UDIM
1380   LINE INPUT #2, TAG$(400 + CT)
1390   PRINT TAG$(400 + CT),
1400  NEXT CT
1410  PRINT
1420  CLOSE #2
1430  '
1440  REM Obtain Current Content of the sub-Array
1450  PRINT "Preparing ";TAG$(4)
1460  OPEN SUBARRAY$ FOR INPUT AS #2
1470  FOR CT = LDIM TO 3
1480   FOR CY = LDIM TO 32
1490    LINE INPUT #2, TEMP$
1491     IF CT = 1 AND CY < 17 THEN TAG$(450+CY) = TEMP$ : PRINT TAG$(450+CY),
1492     IF CT = 2 AND CY < 17 THEN TAG$(500+CY) = TEMP$ : PRINT TAG$(500+CY),
1493     IF CT = 3 AND CY < 17 THEN TAG$(550+CY) = TEMP$ : PRINT TAG$(550+CY),
1500   NEXT CY
1510  NEXT CT
1520  PRINT
1530  CLOSE #2
1540  '
1550  REM Obtain Current Content of Vector2
1560  PRINT "Preparing ";TAG$(5)
1570  OPEN VECTOR2$ FOR INPUT AS #2
1580  FOR CT = LDIM TO UDIM
1590   LINE INPUT #2, TAG$(200 + CT)
1600   PRINT TAG$(200 + CT),
1610  NEXT CT
1620  PRINT
1630  CLOSE #2
1640  '
1650  REM Obtain the Documentation Changes
1660  PRINT "Preparing Documentation Changes"
1670  OPEN "dochange" FOR INPUT AS #2
1680   INPUT #2, TAG.NO
1690   PRINT TAG.NO,
1700   LINE INPUT #2, TAG.VALUE$
1710   PRINT TAG.VALUE$
1720   IF TAG.VALUE$ = "eof" THEN 1750
1730   TAG$(TAG.NO) = TAG.VALUE$
1740   GOTO 1680
1750  CLOSE #2
1760  GOTO 2110
1770  REM subroutine to print a double box
1780  COLOR 5
1790  FOR I = R1 + 1 TO R2 - 1
1800   LOCATE I, C1 : PRINT CHR$(186);
1810   LOCATE I, C2 : PRINT CHR$(186);
1820  NEXT I
1830  FOR J = C1 + 1 TO C2 - 1
1840   LOCATE R1, J : PRINT CHR$(205);
1850   LOCATE R2, J : PRINT CHR$(205);
1860  NEXT J
1870   LOCATE R1, C1 : PRINT CHR$(201);
1880   LOCATE R1, C2 : PRINT CHR$(187);
1890   LOCATE R2, C1 : PRINT CHR$(200);
1900   LOCATE R2, C2 : PRINT CHR$(188);
1910  COLOR 7
1920  RETURN
1930  '
1940  REM subroutine to print a single box
1950  COLOR 3
1960  FOR I = R1 + 1 TO R2 - 1
1970   LOCATE I, C1 : PRINT CHR$(179);
1980   LOCATE I, C2 : PRINT CHR$(179);
1990  NEXT I
2000  FOR J = C1 + 1 TO C2 - 1
2010   LOCATE R1, J : PRINT CHR$(196);
2020   LOCATE R2, J : PRINT CHR$(196);
2030  NEXT J
2040   LOCATE R1, C1 : PRINT CHR$(218);
2050   LOCATE R1, C2 : PRINT CHR$(191);
2060   LOCATE R2, C1 : PRINT CHR$(192);
2070   LOCATE R2, C2 : PRINT CHR$(217);
2080  COLOR 7
2090  RETURN
2100  '
2110  REM Menu of the available Documentation Sections.
2120  CLS
2130  REM Draw the Menu itself.
2140  CLS
2150  REM Draw the Outer Double Box.
2160  R1 = 1 : C1 = 1 : R2 = 23 : C2 = 79 : GOSUB 1770
2170  REM Draw the Heading Separator.
2180  R1 = 3 : C1 = 1 : R2 = 3 : C2 = 79 : GOSUB 2940
2190  REM Draw the Vertical Separators.
2200  R1 = 1 : C1 = 6 : R2 = 23 : C2 = 6 : GOSUB 3030
2210  REM Attach the intersections
2220  COLOR 5
2230  LOCATE 3, 6 : PRINT CHR$(197);
2240  COLOR 7,0
2250  REM Print the content of the menu.
2260  COLOR 0,7
2270  LOCATE 2,3 : PRINT "No";
2280  LOCATE 2,8 : PRINT "Section of the Documentation";
2290  COLOR 7,0
2300  COLOR 0,7 : LOCATE  4,3 : PRINT " 1"; : COLOR 6,0
2310  LOCATE  4, 8 : PRINT "Program Directory"
2320  COLOR 0,7 : LOCATE  6,3 : PRINT " 2"; : COLOR 6,0
2330  LOCATE  6, 8 : PRINT "Title, Copyright, and Table of Contents"
2340  COLOR 0,7 : LOCATE  7,3 : PRINT " 3"; : COLOR 6,0
2350  LOCATE  7, 8 : PRINT "Introduction and Care of Diskettes"
2360  COLOR 0,7 : LOCATE  8,3 : PRINT " 4"; : COLOR 6,0
2370  LOCATE  8, 8 : PRINT "First Time Usage, Startup and Backup"
2380  COLOR 0,7 : LOCATE  9,3 : PRINT " 5"; : COLOR 6,0
2390  LOCATE  9, 8 : PRINT "General Information"
2400  COLOR 0,7 : LOCATE 10,3 : PRINT " 6"; : COLOR 6,0
2410  LOCATE 10, 8 : PRINT "Creating and Extending Data Files"
2420  COLOR 0,7 : LOCATE 11,3 : PRINT " 7"; : COLOR 6,0
2430  LOCATE 11, 8 : PRINT "Introduction to Personalization"
2440  COLOR 0,7 : LOCATE 12,3 : PRINT " 8"; : COLOR 6,0
2450  LOCATE 12, 8 : PRINT "Personalizing the "+TAG$(1)
2460  COLOR 0,7 : LOCATE 13,3 : PRINT " 9"; : COLOR 6,0
2470  LOCATE 13, 8 : PRINT "Personalizing the "+TAG$(5)
2480  COLOR 0,7 : LOCATE 14,3 : PRINT "10"; : COLOR 6,0
2490  LOCATE 14, 8 : PRINT "Personalizing the "+TAG$(3)
2500  COLOR 0,7 : LOCATE 15,3 : PRINT "11"; : COLOR 6,0
2510  LOCATE 15, 8 : PRINT "Personalizing the "+TAG$(4)
2520  COLOR 0,7 : LOCATE 16,3 : PRINT "12"; : COLOR 6,0
2530  LOCATE 16, 8 : PRINT "Personalizing the "+TAG$(2)
2540  COLOR 0,7 : LOCATE 17,3 : PRINT "13"; : COLOR 6,0
2550  LOCATE 17, 8 : PRINT "Data Entry"
2560  COLOR 0,7 : LOCATE 18,3 : PRINT "14"; : COLOR 6,0
2570  LOCATE 18, 8 : PRINT "Record Deletion"
2580  COLOR 0,7 : LOCATE 19,3 : PRINT "15"; : COLOR 6,0
2590  LOCATE 19, 8 : PRINT "Inquiries"
2600  COLOR 0,7 : LOCATE 20,3 : PRINT "16"; : COLOR 6,0
2610  LOCATE 20, 8 : PRINT "Redisplay"
2620  COLOR 0,7 : LOCATE 21,3 : PRINT "17"; : COLOR 6,0
2630  LOCATE 21, 8 : PRINT "How to Stop"
2640  COLOR 0,7 : LOCATE 22,3 : PRINT "18"; : COLOR 6,0
2650  LOCATE 22, 8 : PRINT "Terms and Conditions"
2660  COLOR 7,0
2670  REM Now obtain User Response
2680  LOCATE 24,1 : INPUT "Type a Section Number (0 to quit) and press 'enter'."; REPLY$
2690  IF REPLY$ = "" THEN 2690
2700  REPLY = INT(VAL(REPLY$))
2710  IF REPLY = 0 THEN 6790
2720  IF REPLY < 0 OR REPLY > 18 THEN 2100
2730  IF REPLY =  1 THEN PAGE.NO = -1 : OPEN "director" FOR INPUT AS #1 : GOTO 2920
2740  IF REPLY =  2 THEN PAGE.NO = -5 : OPEN "tableofc" FOR INPUT AS #1 : GOTO 2920
2750  IF REPLY =  3 THEN PAGE.NO = 0 : OPEN "introduc" FOR INPUT AS #1 : GOTO 2920
2760  IF REPLY =  4 THEN PAGE.NO = 4 : OPEN "firstime" FOR INPUT AS #1 : GOTO 2920
2770  IF REPLY =  5 THEN PAGE.NO = 10 : OPEN "geninfor" FOR INPUT AS #1 : GOTO 2920
2780  IF REPLY =  6 THEN PAGE.NO = 16 : OPEN "creatfil" FOR INPUT AS #1 : GOTO 2920
2790  IF REPLY =  7 THEN PAGE.NO = 22 : OPEN "introper" FOR INPUT AS #1 : GOTO 2920
2800  IF REPLY =  8 THEN PAGE.NO = 24 : OPEN "pervect1" FOR INPUT AS #1 : GOTO 2920
2810  IF REPLY =  9 THEN PAGE.NO = 30 : OPEN "pervect2" FOR INPUT AS #1 : GOTO 2920
2820  IF REPLY = 10 THEN PAGE.NO = 36 : OPEN "perarray" FOR INPUT AS #1 : GOTO 2920
2830  IF REPLY = 11 THEN PAGE.NO = 40 : OPEN "persubar" FOR INPUT AS #1 : GOTO 2920
2840  IF REPLY = 12 THEN PAGE.NO = 46 : OPEN "pervect3" FOR INPUT AS #1 : GOTO 2920
2850  IF REPLY = 13 THEN PAGE.NO = 54 : OPEN "dataentr" FOR INPUT AS #1 : GOTO 2920
2860  IF REPLY = 14 THEN PAGE.NO = 72 : OPEN "recdelet" FOR INPUT AS #1 : GOTO 2920
2870  IF REPLY = 15 THEN PAGE.NO = 80 : OPEN "inquirys" FOR INPUT AS #1 : GOTO 2920
2880  IF REPLY = 16 THEN PAGE.NO = 100 : OPEN "redispla" FOR INPUT AS #1 : GOTO 2920
2890  IF REPLY = 17 THEN PAGE.NO = 102 : OPEN "stopping" FOR INPUT AS #1 : GOTO 2920
2900  IF REPLY = 18 THEN PAGE.NO = 106 : OPEN "termcond" FOR INPUT AS #1 : GOTO 2920
2910  STOP
2920  REM File is open, obtain the data, and process it.
2930  GOTO 3130
2940  REM Subroutine to draw a single horizontal line.  Attach to double.
2950  COLOR 5
2960  FOR J = C1 + 1 TO C2 - 1
2970   LOCATE R1,J : PRINT CHR$(196);
2980  NEXT J
2990  LOCATE R1,C1 : PRINT CHR$(199);
3000  LOCATE R1,C2 : PRINT CHR$(182);
3010  COLOR 7
3020  RETURN
3030  REM Subroutine to draw a single vertical line.  Attach to double.
3040  COLOR 5
3050  FOR I = R1 + 1 TO R2 - 1
3060   LOCATE I,C1 : PRINT CHR$(179);
3070  NEXT I
3080  LOCATE R1,C1 : PRINT CHR$(209);
3090  LOCATE R2,C1 : PRINT CHR$(207);
3100  COLOR 7
3110  RETURN
3120  '
3130  REM Text Processor Actually begins here.
3140  REM Program to produce the User's Manual for all YVO Programs.
3150  REM All text is line-input from data files.
3160  '
3170  REM Data for the Title Page and Parameters
3180  DOC.NAME$ = "User's Manual"
3190  IF REPLY = 1 THEN DOC.NAME$ = "Program Directory"
3200  LINE.NO = 1
3210  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
3220  GOSUB 3730  'For heading space
3230  FOR I = 1 TO 6 : LPRINT : NEXT I
3240  LPRINT BOLD.ON$; 'Set Emphasized mode
3250  LPRINT WIDE.ON$;  'Set Expanded Print
3260  LPRINT TAB(TAB.POS-4);"YOUR VERY OWN"
3270  LPRINT WIDE.OFF$;  'Return to normal
3280  FOR I = 1 TO 3 : LPRINT : NEXT I
3290  LPRINT WIDE.ON$;  'Set Expanded Print
3300  LPRINT TAB(TAB.POS-5);TITLE$
3310  LPRINT WIDE.OFF$;  'Return to normal
3320  FOR I = 1 TO 15 : LPRINT : NEXT I
3330  LPRINT WIDE.ON$;  'Set Expanded Print
3340  LPRINT TAB(TAB.POS-5); DOC.NAME$
3350  LPRINT WIDE.OFF$;  'Return to normal
3360  FOR I = 1 TO 15 : LPRINT : NEXT I
3370  LPRINT WIDE.ON$;  'Set Expanded Print
3380  LPRINT TAB(TAB.POS-5); "Melvin O. Duke"
3390  LPRINT WIDE.OFF$;  'Return to normal
3400  LPRINT BOLD.OFF$; 'Return to normal
3410  LINE.NO = LINE.NO + 42
3420  REM Expect .pa or .h1 to follow
3430  '
3440  LINE INPUT #1, REPLY$
3450   PRINT REPLY$
3460  '
3470  REM test for a command
3480  IF LEFT$(REPLY$,1) = "." THEN GOSUB 4040: GOTO 3440
3490  IF LINE.NO > 56 THEN GOSUB 3810
3500  REM Print the line if not a command
3510  REM First turn the tags into text
3520   FORMAT$ = ""
3530   FOR K = 1 TO LEN(REPLY$)
3540    TEST.CHR$ = MID$(REPLY$,K,1)
3550    IF TEST.CHR$ = "~" THEN TEST.CHR$ = CHR$(34)
3560    IF TEST.CHR$ = "^" THEN 3580 ELSE 3640
3570  '
3580     REM Found a Tag, in the form ^nnn
3590     TAG.NO = VAL(MID$(REPLY$,K+1,3))
3600     FORMAT$ = FORMAT$ + TAG$(TAG.NO)
3610     K = K + 3
3620     GOTO 3660
3630  '
3640     REM no tag in this position
3650     FORMAT$ = FORMAT$ + TEST.CHR$
3660   NEXT K
3670   LPRINT TAB(TAB.POS);FORMAT$
3680    PRINT FORMAT$
3690  LINE.NO = LINE.NO + 1
3700  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
3710  GOTO 3440  'for next line-input
3720  '
3730  REM Top of each page routine
3740  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
3750  FOR I = 1 TO 3
3760   LPRINT
3770  NEXT I
3780  LINE.NO = LINE.NO + 3
3790  RETURN
3800  '
3810  REM Bottom of each page Routine
3820  IF PAGE.NO < 1 THEN LPRINT : LPRINT : LPRINT : GOTO 3950
3830  LPRINT TAB(TAB.POS); STRING$(60,45)  'on line 58
3840  CENTER = (LEN(TITLE$)+14)/2
3850  LPRINT TAB(TAB.POS+30-CENTER); "YOUR VERY OWN " + TITLE$  'on line 59
3860  IF PAGE.NO MOD 2 = 1 THEN 3900
3870  LPRINT TAB(TAB.POS);"Page";PAGE.NO;
3880  LPRINT TAB(TAB.POS+60-LEN(DOC.NAME$)); DOC.NAME$
3890  GOTO 3950
3900  LPRINT TAB(TAB.POS); DOC.NAME$;
3910  IF PAGE.NO < 10 THEN DELTA = 54
3920  IF PAGE.NO >  9 THEN DELTA = 53
3930  IF PAGE.NO > 99 THEN DELTA = 52
3940  LPRINT TAB(TAB.POS+DELTA); "Page"; PAGE.NO  'on line 60
3950  REM Page-eject follows
3960  LPRINT PAGE.EJECT$;
3970  PAGE.NO = PAGE.NO + 1
3980  LINE.NO = 1
3990  IF REPLY$ = ".eof" THEN 4010  'Bypass after last page
4000  GOSUB 3730  'For top of next page
4010  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
4020  RETURN
4030  '
4040  REM Command Processor
4050  IF LEFT$(REPLY$,3) = ".h1" THEN 4190       'head-level 1
4060  IF LEFT$(REPLY$,3) = ".h2" THEN 4360       'head-level 2
4070  IF LEFT$(REPLY$,3) = ".h3" THEN 4640       'heal-level 3
4080  IF LEFT$(REPLY$,3) = ".sp" THEN 4920       'single space
4090  IF LEFT$(REPLY$,4) = ".eof" THEN 4980      'end of file
4100  IF LEFT$(REPLY$,3) = ".pa" THEN 5040       'page-eject
4110  IF LEFT$(REPLY$,3) = ".vt" THEN 5120       'vertical tab
4120  IF LEFT$(REPLY$,3) = ".pk" THEN 5240       'compressed
4130  IF LEFT$(REPLY$,3) = ".in" THEN 6440       'indented
4140  IF LEFT$(REPLY$,3) = ".cm" THEN 6480       'comments
4150  IF LEFT$(REPLY$,3) = ".tc" THEN 6510       'table of contents
4160  IF LEFT$(REPLY$,3) = ".pn" THEN 6750       'page Number
4170  STOP : GOTO 4170
4180  '
4190  REM Head 1 Processor  (.h1)
4200  FOR I = LINE.NO TO 57
4210   LPRINT
4220  NEXT I
4230  GOSUB 3810  'Bottom of page Routine
4240  IF PAGE.NO MOD 2 = 0 THEN GOSUB 5040  'For h1 on Odd pages
4250  LPRINT BOLD.ON$;  'Set Emphasized
4260  LPRINT WIDE.ON$;  'Set expanded print
4270  ADJUST = -6
4280  LPRINT TAB(TAB.POS+ADJUST); RIGHT$(REPLY$,LEN(REPLY$)-4)
4290   PRINT RIGHT$(REPLY$,LEN(REPLY$)-4)
4300  LPRINT WIDE.OFF$;  'Return to normal
4310  LPRINT BOLD.OFF$; 'Return to normal
4320  LINE.NO = LINE.NO+1
4330  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
4340  RETURN
4350  '
4360  REM Head 2 Processor (.h2)
4370  IF LINE.NO = 4 THEN 4390 'skip spacing if at top of page
4380  IF LINE.NO > 56 THEN GOSUB 5040 ELSE LPRINT:LPRINT:LINE.NO = LINE.NO+2
4390  REM First turn the tags into text
4400   FORMAT$ = ""
4410   FOR K = 5 TO LEN(REPLY$)
4420    TEST.CHR$ = MID$(REPLY$,K,1)
4430    IF TEST.CHR$ = "~" THEN TEST.CHR$ = CHR$(34)
4440    IF TEST.CHR$ = "^" THEN 4460 ELSE 4520
4450  '
4460     REM Found a Tag, in the form ^nnn at end of reply$
4470     TAG.NO = VAL(MID$(REPLY$,K+1,3))
4480     FORMAT$ = FORMAT$ + TAG$(TAG.NO)
4490     K = LEN(REPLY$)
4500     GOTO 4540
4510  '
4520     REM no tag in this position
4530     FORMAT$ = FORMAT$ + TEST.CHR$
4540   NEXT K
4550  LPRINT BOLD.ON$;  'Set emphasized print
4560  LPRINT TAB(TAB.POS); FORMAT$
4570   PRINT FORMAT$
4580  LPRINT BOLD.OFF$;  'Return to normal
4590  LPRINT
4600  LINE.NO = LINE.NO + 2
4610  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
4620  RETURN
4630  '
4640  REM Head 3 Processor  (.h3)
4650  IF LINE.NO = 4 THEN 4670 'skip spacing if at top of page
4660  IF LINE.NO > 56 THEN GOSUB 5040 ELSE LPRINT:LPRINT:LINE.NO = LINE.NO+2
4670  REM First turn the tags into text
4680   FORMAT$ = ""
4690   FOR K = 5 TO LEN(REPLY$)
4700    TEST.CHR$ = MID$(REPLY$,K,1)
4710    IF TEST.CHR$ = "~" THEN TEST.CHR$ = CHR$(34)
4720    IF TEST.CHR$ = "^" THEN 4740 ELSE 4800
4730  '
4740     REM Found a Tag, in the form ^nnn at end of reply$
4750     TAG.NO = VAL(MID$(REPLY$,K+1,3))
4760     FORMAT$ = FORMAT$ + TAG$(TAG.NO)
4770     K = LEN(REPLY$)
4780     GOTO 4820
4790  '
4800     REM no tag in this position
4810     FORMAT$ = FORMAT$ + TEST.CHR$
4820   NEXT K
4830  LPRINT BOLD.ON$;  'Set emphasized print
4840  LPRINT TAB(TAB.POS); FORMAT$
4850   PRINT FORMAT$
4860  LPRINT BOLD.OFF$;  'Return to normal
4870  LPRINT
4880  LINE.NO = LINE.NO + 2
4890  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
4900  RETURN
4910  '
4920  REM Single Space Processor  (.sp)
4930  IF LINE.NO = 4 THEN 4950
4940  IF LINE.NO > 57 THEN GOSUB 5040 ELSE LPRINT : LINE.NO = LINE.NO + 1
4950  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
4960  RETURN
4970  '
4980  REM End of File Processor  (.eof)
4990  GOSUB 5040 'Bottom of Page
5000  'LPRINT PAGE.EJECT$;
5010  CLOSE #1
5020  GOTO 2110
5030  '
5040  REM Page Eject Processor   (.pa)
5050  FOR I = LINE.NO TO 57
5060   LPRINT
5070   LINE.NO = LINE.NO + 1
5080  NEXT I
5090  GOSUB 3810  'Bottom of Page Processing
5100  RETURN
5110  '
5120  REM Vertical Tab Processor  (.vt)
5130  IF LINE.NO = 4 THEN 5220
5140  IF LINE.NO > 57 THEN GOSUB 3810  'End of page
5150  QTY = VAL(RIGHT$(REPLY$,LEN(REPLY$)-3))
5160  FOR I = 1 TO QTY
5170   LPRINT
5180   LINE.NO = LINE.NO + 1
5190   IF LINE.NO > 57 THEN I = QTY
5200  NEXT I
5210  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
5220  RETURN
5230  '
5240  REM Pack Processor (.pk)
5250  '
5260  REM set the initial format at null
5270  FORMAT$ = ""
5280  '
5290  REM if text begins with a ` then it is a formatted image line
5300  IF MID$(REPLY$,5,1) = "`" THEN 5480
5310  REM scan packed line for tags, and replace if found
5320  FOR K = 5 TO LEN(REPLY$)
5330   TEST.CHR$ = MID$(REPLY$,K,1)
5340   IF TEST.CHR$ = "~" THEN TEST.CHR$ = CHR$(34)
5350   IF TEST.CHR$ = "^" THEN 5370 ELSE 5430
5360  '
5370   REM found a tag in the form ^nnn
5380   TAG.NO = VAL(MID$(REPLY$,K+1,3))
5390   FORMAT$ = FORMAT$ + TAG$(TAG.NO)
5400   K = K + 3
5410   GOTO 5450
5420  '
5430   REM no tag in this position
5440   FORMAT$ = FORMAT$ + TEST.CHR$
5450  NEXT K
5460  GOTO 6280
5470  '
5480  REM Formatted Image Line Processor
5490  REM Text in line began with a ` (grave accent)
5500  LOOK.POS = 6
5510  INSERT.NO = 0
5520  REM Determine mask number to use.
5530  BUILD$ = ""
5540  FOR K = LOOK.POS TO LEN(REPLY$)
5550   IF MID$(REPLY$,LOOK.POS,1) = "`" THEN 5590
5560   BUILD$ = BUILD$ + MID$(REPLY$,LOOK.POS,1)
5570   GOTO 5630
5580  '
5590   REM end of scan
5600   MASK.NO = VAL(BUILD$)
5610   FORMAT$ = MASK$(MASK.NO)
5620   K = LEN(REPLY$)
5630   LOOK.POS = LOOK.POS + 1
5640  NEXT K
5650  '
5660  REM Determine the Number of Insertions
5670  BUILD$ = ""
5680  FOR K = LOOK.POS TO LEN(REPLY$)
5690   IF MID$(REPLY$,LOOK.POS,1) = "`" THEN 5730
5700   BUILD$ = BUILD$ + MID$(REPLY$,LOOK.POS,1)
5710   GOTO 5760
5720  '
5730   REM end of scan
5740   INSERT.NO = VAL(BUILD$)
5750   K = LEN(REPLY$)
5760   LOOK.POS = LOOK.POS + 1
5770  NEXT K
5780  '
5790  REM Now are able to establish the line image
5800  FORMAT$ = MASK$(MASK.NO)
5810  IF MASK.NO = 9 AND TAG$(0) = "no" THEN RETURN  'no summary line
5820  '
5830  REM scan for insertions and place within the formatted line
5840  FOR INSERT = 1 TO INSERT.NO
5850   REM find the insert position
5860   BUILD$ = "" : WHERE = 0
5870   FOR K = LOOK.POS TO LEN(REPLY$)
5880    TEST.CHR$ = MID$(REPLY$,K,1)
5890    IF TEST.CHR$ <> "~" THEN 5920
5900    BUILD$ = BUILD$ + CHR$(34)
5910    GOTO 5980
5920    IF TEST.CHR$ = "`" THEN 5950
5930    BUILD$ = BUILD$ + TEST.CHR$
5940    GOTO 5980
5950    REM found the end of the insert position
5960    K = LEN(REPLY$)
5970    WHERE = VAL(BUILD$)
5980    LOOK.POS = LOOK.POS + 1
5990   NEXT K
6000   REM Now determine the text which needs to be inserted
6010   BUILD$ = ""
6020   FOR K = LOOK.POS TO LEN(REPLY$)
6030    TEST.CHR$ = MID$(REPLY$,K,1)
6040    IF TEST.CHR$ <> "~" THEN 6070
6050    BUILD$ = BUILD$ + CHR$(34)
6060    GOTO 6210
6070    IF TEST.CHR$ <> "`" THEN 6110
6080    REM delimiter character
6090    K = LEN(REPLY$)
6100    GOTO 6210
6110    REM search for a tag
6120    IF TEST.CHR$ <> "^" THEN 6190
6130    REM tag insertion routine
6140    TAG.NO = VAL(MID$(REPLY$,K+1,3))
6150    BUILD$ = BUILD$ + TAG$(TAG.NO)
6160    LOOK.POS = LOOK.POS + 3
6170    K = K + 3
6180    GOTO 6210
6190    REM normal character
6200    BUILD$ = BUILD$ + TEST.CHR$
6210    LOOK.POS = LOOK.POS + 1
6220   NEXT K
6230   WHAT$ = BUILD$
6240   REM now insert the text
6250   IF WHERE = 0 THEN LPRINT "*** ERROR in "; REPLY$ : GOTO 6270
6260   MID$(FORMAT$,WHERE,LEN(WHAT$)) = WHAT$
6270  NEXT INSERT
6280  REM Packed information ready to print
6290  IF LINE.NO > 57 THEN GOSUB 3810
6300  IF TAB.POS = 8 THEN ADJUST = 4
6310  IF TAB.POS = 13 THEN ADJUST = 7
6320  TAB.POS = TAB.POS + ADJUST + INDENT
6330  WIDTH "lpt1:", 132 'set condensed width
6340  REM Now have the line ready to print
6350  LPRINT SQUEEZE.ON$;  'Packed printing
6360  LPRINT TAB(TAB.POS); FORMAT$
6370   PRINT FORMAT$
6380  LPRINT SQUEEZE.OFF$;  'Return to normal
6390  WIDTH "lpt1:", 80  'return to normal
6400  LINE.NO = LINE.NO + 1
6410  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
6420  RETURN
6430  '
6440  REM Indent Processor  (.in)
6450  INDENT = VAL(RIGHT$(REPLY$,LEN(REPLY$)-3))
6460  RETURN
6470  '
6480  REM Comment Processor  (.cm)
6490  RETURN
6500  '
6510  REM Table of Contents Processor  (.tc)
6520  FORMAT$ = ""
6530  FOR DASHES = 1 TO 30 : FORMAT$ = FORMAT$+"- " : NEXT DASHES
6540  REM look for a tag
6550  FOR K = 9 TO LEN(REPLY$)
6560   TEST.CHR$ = MID$(REPLY$,K,1)
6570   IF TEST.CHR$ <> "^" THEN 6650
6580  '
6590   REM character was a tag
6600   TAG.NO = VAL(MID$(REPLY$,K+1,3))
6610   MID$(FORMAT$,K-8,LEN(TAG$(TAG.NO))+1) = TAG$(TAG.NO)+" "
6620   K = LEN(REPLY$)
6630   GOTO 6670
6640  '
6650   REM character was not a tag
6660   MID$(FORMAT$,K-8,1) = TEST.CHR$
6670  NEXT K
6680  MID$(FORMAT$,57,4) = MID$(REPLY$,4,4)
6690  LPRINT TAB(TAB.POS); FORMAT$
6700   PRINT FORMAT$
6710  LINE.NO = LINE.NO + 1
6720  IF PAGE.NO MOD 2 = 0 THEN TAB.POS = 8 ELSE TAB.POS = 13
6730  RETURN
6740  '
6750  REM Page Number Processor  (.pn)
6760  PAGE.NO = VAL(RIGHT$(REPLY$,LEN(REPLY$)-4))
6770  RETURN
6780  '
6790  CLS : LOCATE 21,1
6800  PRINT "End of Program"
6810  END
