10  REM * * * * * * * * * * * F A C T O R * * * * * * * * * * * * * 
15  REM  THIS PROGRAM WAS WRITTEN TO PROVIDE ASSISTANCE IN CALCULATING PRESENT
17  REM  VALUES, FUTURE VALUES, AND PERIODIC PAYMENT AMOUNTS, BASED ON THE
19  REM  COMPUTIONAL METHODS OUTLINED IN TABLE 1 OF THE ASTM STANDARD PRACTICE
21  REM  FOR MEASURING LIFE-CYCLE COSTS OF BUILDINGS AND BUILDING SYSTEMS (E917)
30  REM  PROGRAM AUTHOR: STEVE PETERSEN, NATIONAL BUREAU OF STANDARDS
60  DIM E(30),L(30)
65  I1=-100
70  KEY OFF
75  CLS:PRINT:PRINT:PRINT "NOTE: ENTER ALL DOLLAR VALUES WITHOUT $ SIGN (E.G., 12345.00)."
76  PRINT     "      ENTER DISCOUNT AND ESCALATION RATES WITHOUT % SIGN (E.G. 7.0)."
77  PRINT     "      PRESS CARRIAGE RETURN <CR> AFTER EACH ENTRY."
79  PRINT:PRINT:INPUT "PRESS <CR> FOR MENU...",D$
80  CLS:PRINT "             DISCOUNTING APPLICATIONS MENU"
90  PRINT "-----------------------------------------------------------"
100  PRINT "CODE                         TO FIND:"
110  PRINT "-----   ---------------------------------------------------"
120  PRINT "        ------------------SINGLE AMOUNTS-------------------"
130  PRINT "  1     FUTURE VALUE WHEN PRESENT VALUE IS KNOWN"
140  PRINT "  2     PRESENT VALUE WHEN FUTURE VALUE IS KNOWN"
150  PRINT
160  PRINT "        -------------UNIFORM SERIES OF PAYMENTS------------"
170  PRINT "  3     PERIODIC PAYMENT AMOUNT WHEN FUTURE AMOUNT IS KNOWN"
180  PRINT "  4     PERIODIC PAYMENT AMOUNT WHEN PRESENT AMOUNT IS KNOWN"
190  PRINT "  5     FUTURE VALUE WHEN PERIODIC PAYMENT AMOUNT IS KNOWN"
200  PRINT "  6     PRESENT VALUE WHEN PERIODIC PAYMENT AMOUNT IS KNOWN"
210  PRINT
220  PRINT "        ----------NON-UNIFORM SERIES OF PAYMENTS-----------"
230  PRINT "  7     PRESENT VALUE WHEN PERIODIC PAYMENT AMOUNT INCREASES"
240  PRINT "          AT CONSTANT RATE"
250  PRINT "  8     PRESENT VALUE WHEN PERIODIC PAYMENT AMOUNT INCREASES"
260  PRINT "          AT CHANGING RATE"
270  PRINT "-----------------------------------------------------------"
280  PRINT "    L=LOCK IN DISCOUNT RATE        U=UNLOCK DISCOUNT RATE"
285  PRINT "    D=DEFINE TERMS                 S=STOP"
290  PRINT "-----------------------------------------------------------"
300  INPUT "ENTER APPLICATIONS CODE: ",A$
310  IF A$="S" OR A$="s" THEN 1770
320  IF A$="D" OR A$="d" THEN 1920
330  IF A$="L" OR A$="l" THEN 380
335  IF A$="U" OR A$="u" THEN 336 ELSE 340
336  CLS:PRINT:PRINT:I1=-100:PRINT "DISCOUNT RATE IS UNLOCKED."
337  INPUT "PRESS <CR> TO CONTINUE.",Q$:GOTO 80
340  AA=VAL(A$)
350  IF AA>9 OR AA<1 THEN 80
360  ON AA GOTO 490  ,590  ,680  ,820  ,970  ,1120 ,1260 ,1430 ,1770
370  GOTO 80  
380  CLS:PRINT "IF YOU WANT TO USE THE SAME DISCOUNT (INTEREST) RATE FOR EACH"
390  PRINT "DISCOUNTING APPLICATION, YOU CAN LOCK IN THIS RATE. THE DISCOUNT "
400  PRINT "(INTEREST) RATE CAN BE UNLOCKED BY ENTERING U AT THE MENU LEVEL,"
402  PRINT "BUT YOU CAN LOCK IN A NEW RATE WITHOUT UNLOCKING THE OLD RATE."
405  PRINT:PRINT
410  INPUT "ENTER DISCOUNT (INTEREST) RATE TO BE LOCKED IN: ",I1
420  IF I1<>-100 THEN 440
430  PRINT "DISCOUNT (INTEREST) RATE CANNOT BE SET TO -100%. TRY AGAIN.":GOTO 410
440  PRINT:PRINT USING "###.#% WILL BE USED AS DISCOUNT (INTEREST) RATE UNTIL IT IS UNLOCKED";I1
450  PRINT:INPUT "PRESS <CR> TO CONTINUE",Q$:GOTO 80
460  PRINT:PRINT:PRINT:AA=0:I=0:N=0:E=0:P=0:F=0
470  INPUT "TO FIND ANOTHER AMOUNT, RE-ENTER CODE NUMBER OR PRESS <CR> TO RETURN TO MENU: ",A$
480  GOTO 310
490  CLS
500  PRINT "1. TO FIND FUTURE VALUE WHEN PRESENT VALUE IS KNOWN:"
510  PRINT
520  GOSUB 1810
530  F1=(1+I)^N :F=P*F1
540  PRINT
550  PRINT USING "$$#######.## = FUTURE VALUE OF $$#######.## ";F,P
560  PRINT USING "               AFTER ### TIME PERIODS";N
570  PRINT USING "               AT###.#% DISCOUNT (INTEREST) RATE";I*100
574  PRINT
575  PRINT USING "               SINGLE COMPOUND AMOUNT FACTOR =###.##";F/P
580  GOTO 460
590  CLS:PRINT "2. TO FIND PRESENT VALUE WHEN FUTURE VALUE IS KNOWN:"
600  PRINT
610  GOSUB 1820
620  P1=1/(1+I)^N:P=F*P1
630  PRINT
640  PRINT USING "$$#######.## = PRESENT VALUE OF $$#######.##";P,F
650  PRINT USING "               AFTER ### TIME PERIODS";N
660  PRINT USING "               AT###.#% DISCOUNT (INTEREST) RATE";I*100
664  PRINT
665  PRINT USING "               SINGLE PRESENT VALUE (WORTH) FACTOR = ##.##";P/F
670  GOTO 460  
680  CLS:PRINT "3. TO FIND THE PERIODIC PAYMENT AMOUNT WHEN THE "
690  PRINT "   FUTURE VALUE IS KNOWN:"
700  PRINT
710  GOSUB 1820
720  IF I<>0 THEN 740
730  A1=1/N:GOTO 750
740  A1=I/((1+I)^N-1)
750  A=F*A1
760  PRINT
770  PRINT USING "$$#####.## = END-OF-PERIOD PAYMENT";A
780  PRINT USING "             YIELDING FUTURE VALUE OF $$#######.##";F
790  PRINT USING "             OVER ### TIME PERIODS";N
800  PRINT USING "             AT###.#% DISCOUNT (INTEREST) RATE";I*100
804  PRINT
805  PRINT USING "             UNIFORM SINKING FUND FACTOR =###.##";A/F
810  GOTO 460  
820  CLS
830  PRINT "4. TO FIND THE PERIODIC PAYMENT AMOUNT WHEN THE "
840  PRINT "   PRESENT VALUE IS KNOWN:"
850  PRINT
860  GOSUB 1810
870  IF I=0 THEN 890  
880  A1=I*(1+I)^N/((1+I)^N-1):GOTO 900
890  A1=1/N
900  A=P*A1
910  PRINT
920  PRINT USING "$$#####.##  = END-OF-PERIOD PAYMENT";A
930  PRINT USING "              YIELDING PRESENT VALUE OF $$#######.##";P
940  PRINT USING "              OVER ### TIME PERIODS";N
950  PRINT USING "              AT###.#% DISCOUNT (INTEREST) RATE";I*100
954  PRINT
955  PRINT USING "              UNIFORM CAPITAL RECOVERY FACTOR =###.##";A/P
960  GOTO 460  
970  CLS
980  PRINT "5. TO FIND THE FUTURE VALUE OF A UNIFORM PERIODIC PAYMENT AMOUNT:"
990  PRINT
1000  GOSUB 1800
1010  IF I<>0 THEN 1040  
1020  F1=N
1030  GOTO 1050
1040  F1=((1+I)^N-1)/I
1050  F=A*F1
1060  PRINT
1070  PRINT USING "$$#####.##  = FUTURE VALUE OF";F
1080  PRINT USING "              PERIODIC PAYMENT AMOUNT OF $$#######.##";A
1090  PRINT USING "              AFTER ### TIME PERIODS";N
1100  PRINT USING "              AT###.#% DISCOUNT (INTEREST) RATE";I*100
1104  PRINT
1105  PRINT USING "              UNIFORM COMPOUND AMOUNT FACTOR =###.##";F/A
1110  GOTO 460  
1120  CLS
1130  PRINT "6. TO FIND THE PRESENT VALUE OF A UNIFORM PERIODIC PAYMENT AMOUNT:"
1140  PRINT
1150  GOSUB 1800
1160  IF I=0 THEN 1180 
1170  P1=((1+I)^N-1)/(I*(1+I)^N):GOTO 1190
1180  P1=N
1190  P=P1*A
1200  PRINT
1210  PRINT USING "$$#####.##  = PRESENT VALUE OF";P
1220  PRINT USING "              PERIODIC PAYMENT AMOUNT OF $$#######.##";A
1230  PRINT USING "              OVER ### TIME PERIODS";N
1240  PRINT USING "              AT###.#% DISCOUNT (INTEREST) RATE";I*100
1244  PRINT
1245  PRINT USING "              UNIFORM PRESENT VALUE (WORTH) FACTOR =###.##";P/A
1250  GOTO 460  
1260  CLS
1270  PRINT "7. TO FIND THE PRESENT VALUE OF A PERIODIC PAYMENT AMOUNT"
1280  PRINT "   INCREASING AT A CONSTANT RATE:"
1290  PRINT
1300  GOSUB 1780
1310  INPUT "ENTER ESCALATION RATE (PER TIME PERIOD) FOR PAYMENT AMOUNT (%): ",E:E=E/100
1320  IF E=I THEN 1340
1330  P1=((1+E)/(I-E))*(1-((1+E)/(1+I))^N):GOTO 1350
1340  P1=N
1350  P=P1*A
1360  PRINT
1370  PRINT USING "$$#####.##  = PRESENT VALUE OF PERIODIC PAYMENTS";P
1380  PRINT USING "              HAVING AN INITIAL VALUE OF $$#######.##";A
1390  PRINT USING "              AND INCREASING AT###.##% PER TIME PERIOD";E*100
1400  PRINT USING "              OVER ### TIME PERIODS";N
1410  PRINT USING "              AT###.#% DISCOUNT (INTEREST) RATE";I*100
1414  PRINT
1415  PRINT USING "              MODIFIED UNIFORM PRESENT VALUE (WORTH) FACTOR =###.##";P/A
1420  GOTO 460  
1430  CLS
1440  PRINT "8. TO FIND THE PRESENT VALUE OF A PERIODIC PAYMENT AMOUNT"
1450  PRINT "   INCREASING AT A CHANGING RATE:"
1460  PRINT
1470  N2=0:T=0
1480  GOSUB 1780
1490  N2=N2+1
1500  PRINT USING "ENTER ESCALATION RATE NO. ##";N2;:INPUT " FOR PAYMENT AMOUNT (%): ",E(N2):E(N2)=E(N2)/100
1510  PRINT USING "ENTER NUMBER OF TIME PERIODS FOR ESCALATION RATE NO. ##";N2;:INPUT L(N2)
1520  T=T+L(N2):IF T>N THEN 1530 ELSE IF T=N THEN 1570 ELSE 1490
1530  PRINT
1540  L(N2)=L(N2)-(T-N)
1550  PRINT USING "(NOTE: YOUR TIME PERIODS ADD UP TO###; THIS IS MORE THAN";T
1560  PRINT USING "YOU ORIGINALLY SPECIFIED (###). THE LAST INPUT IS REDUCED TO###";N,L(N2)
1570  D1=0
1580  FOR K=1 TO N2
1590  D9=1:FOR J=0 TO K-1:D9=D9*((1+E(J))/(1+I))^L(J):NEXT J
1600  IF I=E(J) THEN 1620 
1610  D8=(1+E(J))/(I-E(J))*(1-((1+E(J))/(1+I))^L(J)):GOTO 1630 
1620  D8=L(J)
1630  D1=D1+D8*D9
1640  NEXT K
1650  P=D1*A
1660  PRINT
1670  PRINT USING "$$#####.##  = PRESENT VALUE OF PERIODIC PAYMENTS";P
1680  PRINT USING "              HAVING AN INITIAL VALUE OF $$#######.##";A
1690  PRINT       "              AND INCREASING AT"
1700  FOR K=1 TO N2
1710  PRINT USING "                ###.#% FOR### TIME PERIODS";E(K)*100,L(K)
1720  NEXT K
1730  PRINT USING "                 (TOTAL TIME PERIODS =###)";N
1740  PRINT USING "              AT###.#% DISCOUNT (INTEREST) RATE";I*100
1744  PRINT
1745  PRINT USING "              MODIFIED UNIFORM PRESENT VALUE (WORTH) FACTOR =###.##";P/A
1750  PRINT
1760  GOTO 460
1770  END
1780  INPUT "ENTER PAYMENT AMOUNT, UNADJUSTED FOR RATE CHANGES: ",A:GOTO 1830
1800  INPUT "ENTER PERIODIC PAYMENT AMOUNT: ",A:GOTO 1830
1810  INPUT "ENTER PRESENT AMOUNT: ",P:GOTO 1830
1820  INPUT "ENTER FUTURE AMOUNT: ",F
1830  INPUT "ENTER TOTAL NUMBER OF TIME PERIODS (USUALLY YEARS): ",N
1840  IF N>1 THEN 1860
1850  PRINT "NUMBER OF TIME PERIODS MUST BE GREATER THAN 1.":GOTO 1830
1860  IF I1=-100 THEN 1890
1870  I=I1/100
1880  RETURN
1890  INPUT "ENTER DISCOUNT (INTEREST) RATE (%): ",I:I=I/100
1900  IF I<>-1 THEN RETURN
1910  PRINT "DISCOUNT RATE CANNOT BE SET TO -100%. DO AGAIN.":GOTO 1890
1920  CLS
1930  PRINT "        DEFINITIONS OF TERMS"
1940  PRINT "--------------------------------------------------"
1950  PRINT "CODE          TERM TO BE DEFINED"
1960  PRINT "----      ---------------------------"
1970  PRINT " 1          DISCOUNT RATE"
1980  PRINT " 2          ESCALATION RATE"
1990  PRINT " 3          FUTURE VALUE"
2000  PRINT " 4          INTEREST RATE"
2010  PRINT " 5          NON-UNIFORM SERIES"
2020  PRINT " 6          PERIODIC PAYMENT AMOUNT"
2030  PRINT " 7          PRESENT VALUE"
2040  PRINT " 8          STUDY PERIOD"
2050  PRINT " 9          TIME PERIOD"
2055  PRINT "10          UNIFORM SERIES"
2060  PRINT "--------------------------------------------------"
2070  PRINT "    R=RETURN TO MAIN MENU          S=STOP"
2080  PRINT "--------------------------------------------------"
2090  INPUT "ENTER CODE FOR DEFINITION: ",B$
2100  IF B$="R" OR B$="r" THEN 80
2110  IF B$="S" OR B$="s" THEN 1770
2120  BB=VAL(B$)
2130  IF BB<1 OR BB>10 THEN 1920
2140  CLS:PRINT:PRINT:PRINT:ON BB GOTO 2220,2440,2190,2270,2410,2350,2160,2454,2290,2380
2150  GOTO 1920
2160  PRINT "PRESENT VALUE - THE VALUE OF A BENEFIT OR COST FOUND BY DISCOUNTING"
2170  PRINT "  FUTURE CASH FLOWS TO THE BASE TIME (SYN. PRESENT WORTH)."
2180  GOTO 2460
2190  PRINT "FUTURE VALUE - THE VALUE OF A BENEFIT OR A COST AT SOME POINT IN THE"
2200  PRINT "  FUTURE (USUALLY, THE END OF THE STUDY PERIOD), CONSIDERING"
2205  PRINT "  THE TIME VALUE OF MONEY (SYN. FUTURE WORTH)."
2210  GOTO 2460
2220  PRINT "DISCOUNT RATE - THE RATE OF INTEREST PER TIME PERIOD REFLECTING"
2230  PRINT "  THE INVESTOR'S TIME VALUE OF MONEY, USED TO DETERMINE DISCOUNT"
2240  PRINT "  FACTORS FOR CONVERTING BENEFITS AND COSTS OCCURRING AT DIFFERENT"
2245  PRINT "  TO A BASE TIME OR FUTURE TIME."
2260  GOTO 2460
2270  PRINT "INTEREST RATE - SEE DISCOUNT RATE."
2280  GOTO 2460
2290  PRINT "TIME PERIOD - THE INTERVAL OF TIME OVER WHICH THE DISCOUNT RATE,"
2300  PRINT "  ESCALATION RATE(S), AND PERIODIC PAYMENTS (OR RECEIPTS) ARE SPECIFIED,"
2310  PRINT "  E.G., YEAR, MONTH."
2320  PRINT "  NOTE: THE LENGTH OF THE TIME PERIOD MUST BE CONSISTENT WHEN SPECIFYING"
2330  PRINT "  THE DISCOUNT RATE, ESCALATION RATE(S), AND THE PERIODIC PAYMENT AMOUNT."
2340  GOTO 2460
2350  PRINT "PERIODIC PAYMENT AMOUNT - A CASH AMOUNT PAID OR RECEIVED AT THE END"
2360  PRINT "  OF EACH TIME PERIOD."
2370  GOTO 2460
2380  PRINT "UNIFORM SERIES - A SERIES OF PERIODIC PAYMENTS THAT ARE THE SAME IN"
2390  PRINT "  EVERY TIME PERIOD."
2400  GOTO 2460
2410  PRINT "NON-UNIFORM SERIES - A SERIES OF PERIODIC PAYMENTS THAT CHANGE FROM"
2420  PRINT "  PERIOD TO PERIOD AT A KNOWN RATE."
2430  GOTO 2460
2440  PRINT "ESCALATION RATE - THE RATE OF CHANGE FROM PERIOD TO PERIOD THAT"
2450  PRINT "  CHARACTERIZES A NON-UNIFORM PAYMENT (OR RECEIPT) AMOUNT."
2452  GOTO 2460
2454  PRINT "STUDY PERIOD - THE LENGTH OF TIME OVER WHICH AN INVESTMENT IS ANALYZED"
2456  PRINT "  (SYN. LIFE CYCLE, TIME HORIZON)."
2460  PRINT:PRINT:INPUT "PRESS <CR> TO CONTINUE";Q$:GOTO 1920
