10  'PROGRAM NAME = FBLCC (FEDERAL BUILDINGS VERSION OF BLCC)
20  'THIS IS THE INTRODUCTORY PROGRAM TO THE FBLCC COMPUTER PROGRAM.
30  'AUTHOR: STEVE PETERSEN, NATIONAL BUREAU OF STANDARDS
40  'LAST UPDATED 3-4-86
95  KEY OFF:CLS
100  PRINT "* * * * * * * * * * * * * * * F B L C C * * * * * * * * * * * * * * * * * * * *"
105  PRINT
110  PRINT "FBLCC computes the LIFE-CYCLE COST (LCC) of Federal buildings (or related"
120  PRINT "subsytems) and COMPARES the LCC of alternative building (or subsystem) designs"
130  PRINT "having the same purpose.  An FBLCC analysis is most useful in the evaluation of"
131  PRINT "first cost--future cost tradeoffs, i.e., increases in initial design or "
132  PRINT "construction costs which reduce future operating-related costs (e.g., energy"
133  PRINT "costs) but do not affect the overall usefulness of the building (e.g., the"
135  PRINT "useful floor area)."
140  PRINT:PRINT
150  PRINT "The computational rules for a LCC analysis of a Federal project depend on the "
155  PRINT "purpose of that project:"
160  PRINT "(1) For ENERGY CONSERVATION or RENEWABLE ENERGY PROJECTS, LCC computations are"
165  PRINT "    based on NBS HANDBOOK 135, 'Life-Cycle Cost Manual for the Federal Energy"
170  PRINT "    Management Program,' (revised 1982)."
175  PRINT "(2) For other evaluations requiring an analysis of first cost--future cost "
180  PRINT "    tradeoffs, LCC computations are based on OMB Circular A-94, 'Discount Rate"
185  PRINT "    to Be Used in Evaluating Time-Distributed Costs and Benefits,' March 27,"
186  PRINT "    1972."
190  PRINT:PRINT "* * * * * * * * * * * * * * * F B L C C * * * * * * * * * * * * * * * * * * * *"
195  PRINT:INPUT "press <ENTER> to continue...",QQ$
200  CLS:PRINT:PRINT:PRINT "FBLCC consists of 5 subprograms, each with a distinct function:"
210  PRINT "(1) LCCDATA - A user-interactive program for creating or modifying a BUILDING "
220  PRINT "    CHARACTERISTICS FILE (BCF) for a particular building or subsystem design."
225  PRINT "    The BCF is a complete list of all the data and assumptions for that design."
230  PRINT "(2) PRINTBCF - Prints the BCF created or modified by (1)."
240  PRINT "(3) LCCMAIN - Computes the LCC for a building or subsystem, based on its BCF."
250  PRINT "(4) PRINTLCC - Prints a detailed LCC REPORT based on the results of (3)."
260  PRINT "(5) COMPARE - Computes and prints a COMPARATIVE LCC ANALYSIS of two alternative":PRINT "    building or subsystem designs."
265  PRINT:PRINT
270  PRINT "You must create a BUILDING CHARACTERISTICS FILE for a project with LCCDATA"
272  PRINT "before running PRINTBCF or LCCMAIN.  You must compute the LCC of the project":PRINT "with LCCMAIN before running PRINTLCC.   You must run LCCMAIN for a base"
273  PRINT "case and at least one alternative design before running COMPARE."
276  PRINT:INPUT "Enter subprogram code to proceed (or <ENTER> to stop): ",PN$
278  IF PN$="" THEN 850 ELSE PN=VAL(PN$)
280  IF PN<1 OR PN>5 THEN INPUT PN:GOTO 276
290  ON PN GOTO 300,400,500,600,700
300  FL$="LCCDATA":GOTO 800
400  FL$="PRINTBCF":GOTO 800
500  FL$="LCCMAIN":GOTO 800
600  FL$="PRINTLCC":GOTO 800
700  FL$="COMPARE"
800  PRINT "LOADING ";FL$
810  FL$=FL$+".BAS"
830  CHAIN FL$
850  INPUT "EXIT TO SYSTEM (S) OR BASIC (B)";QQ$
860  IF QQ$="S" OR QQ$="s" THEN SYSTEM ELSE END
19900  SAVE "B:INTRO.BAS"
