10     CLS
20     PRINT :  PRINT : PRINT
30     PRINT   TAB( 20)"--------------------------------------"
40     PRINT   TAB( 20)"  SUNRISE, SUNSET, TWILIGHT OF SUN    "
50     PRINT   TAB( 20)"--------------------------------------"
60     PRINT :  PRINT
70     PRINT   TAB( 26) " AN ASTRONOMY PROGRAM"
80     PRINT
90     PRINT   TAB( 18) " ADAPTED BY CHRIS SPRATT - JUNE, 1985
100     REM
110    PRINT   TAB( 21) " FROM A PROGRAM BY WILLIAM C. BELL"
115    PRINT TAB(17) "PUBLISHED IN ASTRONOMY MAGAZINE - APRIL, 1984"
120     LOCATE 24, 25:PRINT  "PRESS ANY KEY TO CONTINUE"
130       IF INKEY$ = "" THEN 130
140     CLS:PRINT :PRINT :PRINT
150  REM  PURPOSE --
160  REM
170  REM  THIS PROGRAM GIVES THE TIME OF SUNRISE, SUNSET, AND
180  REM  TWILIGHT  (ASTRONOMICAL, NAUTICAL, AND CIVIL)
190  REM  TO WITHIN A MINUTE OR TWO DURING THE SECOND HALF OF
200  REM  THE TWENTIETH CENTURY.
210  REM
220  REM  INPUTS --
230  REM
240  REM  LATITUDE IN DEGREES, MIMUTES, AND SECONDS.
250  REM  NORTH IS POSITIVE.
260  REM  EXAMPLE: 30.0028 REPRESENTS 30
270  REM  DEGREES, 00 MINUTES, 28 SECONDS
280  REM  NORTH LATITUDE.
290  REM
300  REM  LONGITUDE IN DEGREES, MINUTES, AND SECONDS,
310  REM  WEST IS POSITIVE.
320  REM  EXAMPLE: 90.1109 REPRESENTS 90 DEGREES,
330  REM  11 MINUTES, 09 SECONDS, WEST LONGITUDE.
340  REM
350  REM  TIME ZONE IN HOURS AND MINUTES THAT ARE ADDED TO WALL
360  REM  CLOCK TIME TO YIELD UNIVERSAL TIME.
370  REM  IN THE 48 CONTIGOUS UNITED STATES AND CANADA,
380  REM  SEE TABLE BELOW.
390  REM
400  REM                   STANDARD  DAYLIGHT
410  REM
420  REM    EASTERN          5.00      4.00
430  REM    CENTRAL          6.00      5.00
440  REM    MOUNTAIN         7.00      6.00
450  REM    PACIFIC          8.00      7.00
460  REM
470  REM  YEAR (1951 THRU 2000)
480  REM
490  REM  MONTH (1 THRU 12)
500  REM
510  REM  DAY (1 THRU 31)
520  REM
530  REM  OUTPUTS --
540  REM
550  REM  OUTPUTS ARE GIVEN IN HOURS AND MINUTES ON A 24
560  REM  HOUR BASIS, EXAMPLE: 6.25 REPRESENTS 6:25 A.M.,
570  REM  AND 18.25 REPRESENTS 6:25 P.M.
580  REM
590  REM  A ZERO OUTPUT INDICATES THAT THE PHENOMENON
600  REM  DOES NOT OCCUR ON THE SPECIFIED DATE,
610  REM  E.G., THE SUN DOES NOT SET IN MID-SUMMER AT
620  REM  HIGH LATITUDES.
630  REM
640  REM  SAMPLE --
650  REM
660  REM  LATITUDE
670  REM  ? 30
680  REM  LONGITUDE
690  REM  ? 90
700  REM  TIME ZONE
710  REM  ? 5
720  REM  YEAR
730  REM  ? 1983
740  REM  MONTH
750  REM  ? 5
760  REM  DAY
770  REM  ? 19
780  REM
790  REM  A DAWN  4.33
800  REM  N DAWN  5.06
810  REM  C DAWN  5.38
820  REM  SUNRIS  6.04
830  REM  SUNSET  19.49
840  REM  C DUSK  20.15
850  REM  N DUSK  20.47
860  REM  A DUSK  21.21
870  REM
880  REM - CONSTANTS
890  REM
900    LET A=1.5708
910    LET B=3.14159
920    LET C=4.71239
930    LET D=6.28319
940  REM
950  REM - INPUTS
960  REM
970    CLS:PRINT :PRINT :PRINT
980    PRINT  TAB( 20) "LATITUDE";
990    INPUT Z
1000    GOSUB 1850
1010    LET E=Z*.0174533
1020  REM
1030    PRINT  TAB( 20) "LONGITUDE";
1040    INPUT Z
1050    GOSUB 1850
1060    LET F=Z*.0174533
1070  REM
1080    PRINT  TAB( 20) "TIME  ZONE";
1090    INPUT Z
1100    GOSUB 1850
1110    LET G=Z*.261799
1120  REM
1130    PRINT  TAB( 21) "YEAR";
1140    INPUT H
1150  REM
1160    PRINT  TAB( 20) "MONTH";
1170    INPUT I
1180  REM
1190    PRINT  TAB( 22) "DAY";
1200    INPUT J
1210  REM
1220  REM - DAY OF YEAR
1230  REM
1240    LET K=INT((I+9)/12)
1250    LET X=H/4
1260    LET Y=INT(X)
1270    LET Z=X-Y
1280    IF Z=0 THEN 1300
1290    LET K=K*2
1300    LET H=INT(275*I/9)
1310    LET H=H+J-K-30
1320  REM
1330  REM - RISING PHENOMENA
1340  REM
1350    PRINT  "  "
1360  REM
1370    LET I=0
1380    LET J=A
1390    GOSUB 1990
1400  REM
1410    LET R=-.309017
1420    GOSUB 2520
1430    PRINT  TAB( 18) "A DAWN ";V
1440  REM
1450    LET R=-.207912
1460    GOSUB 2520
1470    PRINT  TAB( 18) "N DAWN ";V
1480  REM
1490    LET R=-.104528
1500    GOSUB 2520
1510    PRINT  TAB( 18)  "C DAWN ";V
1520  REM
1530    LET R=-.0145439
1540    GOSUB 2520
1550    PRINT  TAB( 18)  "SUNRIS ";V
1560  REM
1570  REM - SETTING PHENOMENA
1580  REM
1590    LET I=1
1600    LET J=C
1610    GOSUB 1990
1620  REM
1630    LET R=-.0145439
1640    GOSUB 2520
1650    PRINT  TAB( 18)   "SUNSET ";V
1660  REM
1670    LET R=-.104528
1680    GOSUB 2520
1690    PRINT  TAB( 18)   "C DUSK ";V
1700  REM
1710    LET R=-.207912
1720    GOSUB 2520
1730    PRINT  TAB( 18)   "N DUSK ";V
1740  REM
1750    LET R=-.309017
1760    GOSUB 2520
1770    PRINT  TAB( 18)   "A DUSK ";V
1780  REM
1790    PRINT :PRINT
1800    PRINT TAB(15): INPUT "DO YOU WANT ANOTHER DATE Y/N ";A$
1810    IF A$ = "Y" THEN   GOTO  970  ELSE 3080
1820  REM
1830  REM - SEXAGESIMAL TO DECIMAL
1840  REM
1850    LET W=1
1860    IF Z>=0 THEN 1890
1870    LET W=-1
1880    LET Z=ABS(Z)
1890    LET X=Z+.00005
1900    LET X = INT(Z)
1910    LET Z=(Z-X)*100
1920    LET Y=INT(Z)
1930    LET Z=(Z-Y)*100
1940    LET Z=(X+Y/60+Z/3600)*W
1950    RETURN
1960  REM
1970  REM - APPROXIMATE TIME
1980  REM
1990    LET K=H+((J+F)/D)
2000  REM
2010  REM - SOLAR MEAN ANOMALY
2020  REM
2030    LET L=K*.017202
2040    LET L=L-.0574039
2050  REM
2060  REM - SOLAR TRUE LONGITUDE
2070  REM
2080    LET Z=SIN(L)
2090    LET M=L+.0334405*Z
2100    LET Z=SIN(2*L)
2110    LET M=M+3.49066E-04*Z
2120    LET M=M+4.93289
2130  REM
2140  REM - QUADRANT DETERMINATION
2150  REM
2160    LET Z=M
2170    GOSUB 3010
2180    LET M=Z
2190    LET X=M/A
2200    LET Y=INT(X)
2210    LET Z=X-Y
2220    IF Z<>0 THEN 2240
2230    LET M=M+4.84814E-06
2240    LET N=2
2250    IF M>C THEN 2320
2260    LET N=1
2270    IF M>A THEN 2320
2280    LET N=0
2290  REM
2300  REM - SOLAR RIGHT ASCENSION
2310  REM
2320    LET P=SIN(M)/COS(M)
2330    LET P=ATN(.91746*P)
2340  REM
2350  REM - QUADRANT ADJUSTMENT
2360  REM
2370    IF N=0 THEN 2450
2380    IF N=2 THEN 2410
2390    LET P=P+B
2400    GOTO 2450
2410    LET P=P+D
2420  REM
2430  REM - SOLAR DECLINATION
2440  REM
2450    LET Q=.39782*SIN(M)
2460    LET Q=Q/SQR(-Q*Q+1)
2470    LET Q=ATN(Q)
2480    RETURN
2490  REM
2500  REM - COORDINATE CONVERSION
2510  REM
2520    LET S=R-(SIN(Q)*SIN(E))
2530    LET S=S/(COS(Q)*COS(E))
2540  REM
2550  REM - NULL PHENOMENON
2560  REM
2570    LET Z=ABS(S)
2580    IF Z<=1 THEN 2640
2590    LET V=0
2600    RETURN
2610  REM
2620  REM - ADJUSTMENT
2630  REM
2640    LET S=S/SQR(-S*S+1)
2650    LET S=-ATN(S)+A
2660    IF I=1 THEN 2710
2670    LET S=D-S
2680  REM
2690  REM - LOCAL APPARENT TIME
2700  REM
2710    LET Z=.0172028*K
2720    LET T=S+P-Z-1.73364
2730  REM
2740  REM - UNIVERSAL TIME
2750  REM
2760    LET U=T+F
2770  REM
2780  REM - WALL CLOCK TIME
2790  REM
2800    LET V=U-G
2810  REM
2820  REM - DECIMAL TO SEXAGESIMAL
2830  REM
2840    LET Z=V
2850    GOSUB 3010
2860    LET Z=Z*3.81972
2870    LET V=INT(Z)
2880    LET W=(Z-V)*60
2890    LET X=INT(W)
2900    LET Y=W-X
2910    IF Y<.5 THEN 2930
2920    LET X=X+1
2930    IF X<60 THEN 2960
2940    LET V=V+1
2950    LET X=0
2960    LET V=V+X/100
2970    RETURN
2980  REM
2990  REM - NORMALIZATION
3000  REM
3010    IF Z>=0 THEN 3040
3020    LET Z=Z+D
3030    GOTO 3010
3040    IF Z<D THEN 3070
3050    LET Z=Z-D
3060    GOTO 3040
3070    RETURN
3080    END
