100 'Loan Cost ("LOANCOST")
110 CLS
120 COLOR 0,15 : PRINT "Loan Cost" : COLOR 15,0
130 PRINT
140 DEFSNG A-Z
150 DEFINT M-N
160 MONEYFMT$ = "$$##,###,###.##"
170 '     Let user choose type of loan
180 PRINT "Select type of loan"
190 PRINT
200 PRINT "1 - Fully amortized"
210 PRINT "2 - Rule of 78s"
220 PRINT "3 - Interest only plus balloon payment"
230 PRINT
240 INPUT "Type of loan (1-3): ", TYPE
250 IF (TYPE < 1) OR (TYPE > 3)  THEN PRINT "Select 1-3 only" : PRINT: GOTO 200
260 PRINT : PRINT "Do not enter dollar signs or commas" : PRINT
270 '     Let user enter amount, term, rates
280 INPUT "Loan amount: ", PNCPL
290 INPUT "Term in months: ", NMONTHS
300 INPUT "Annual interest rate on loan (in percent): ", AR
310 INPUT "Annual interest rate on savings (in percent): ", SR
320 INPUT "Marginal tax rate (in percent): ", TAXRATE
330 '     Initialize variables
340 PR = AR / 1200                     'Monthly interest rate on loan
350 SR = (1 + SR / 100) ^ (1/12) - 1   'Monthly interest rate on savings
360 SR = SR * (1 - TAXRATE / 100)
370 'Determine monthly payment
380 IF TYPE = 1 OR TYPE = 2 THEN PMT = (PNCPL * PR) / (1 - (1 + PR) ^ -NMONTHS)
390 IF TYPE = 3  THEN PMT = PNCPL * PR
400 TFC = PMT * NMONTHS - PNCPL        'Total finance charge for Rule of 78s
410 '      Calculate amortization
420 PV = 0
430 FOR M = 1 TO NMONTHS
440   IF TYPE = 1 OR TYPE = 3  THEN INTERESTDUE = PNCPL * PR
450   IF TYPE = 2  THEN INTERESTDUE = TFC * 2 * (NMONTHS - M + 1) /                                (NMONTHS * (NMONTHS + 1) )
460   PNCPL = PNCPL - PMT + INTERESTDUE
470   PV = PV + (PMT - INTERESTDUE * TAXRATE / 100) * (1 + SR) ^ -M
480 NEXT M
490 IF TYPE = 3  THEN PV = PV + PNCPL * (1 + SR) ^ -NMONTHS
500 PRINT
510 PRINT "After-tax cost of loan: "; USING MONEYFMT$; PV
520 END
